<template>
    <div>
        <base-header class="header pb-8 pt-5 pt-lg-8 d-flex align-items-center">
            <b-breadcrumb :items="items"></b-breadcrumb>    
            <!-- Mask -->
        </base-header>
        <div class="container-fluid mt--7">
            <div class="row">
                <div class="col">
                    <div class="card shadow">
                        <div class="card-header border-0">
                        <div class="row align-items-center">
                            <div class="col">
                            <h3 class="mb-0">
                                {{title}}
                            </h3>
                            <select name="list-app" v-model="listBuiding" class="custom-select d-block w-100" @change="getBuiding()">
                                <option v-for="(buiding,index) in buidingData" :key="index" :value="buiding.buiding">{{buiding.buiding}}</option>
                            </select>
                            <span class="text-danger" v-if="error !== ''">{{error}}</span>
                            </div>
                            <div class="col text-right">
                                <button class="btn btn-lg btn-primary" @click="showCreate = true">Create Floor</button>
                            </div>
                            <div>
                                <modal :show="showCreate" @close="showCreate = false">
                                    <template slot="header">
                                        <h5 class="modal-title">Create</h5>
                                    </template>
                                    <div>
                                        <div class="col-lg-12">
                                            <base-input alternative=""
                                                        label="Buiding name"
                                                        placeholder="Buiding name"
                                                        input-classes="form-control-alternative"
                                                        v-model="floor_name"
                                            />
                                            <span class="text-danger" v-if="error !== ''">{{error}}</span>
                                        </div>
                                    </div>
                                    <template slot="footer">
                                            <base-button type="secondary" @click="showCreate = false">Close</base-button>
                                            <base-button type="primary" @click="checkData">Create</base-button>
                                    </template>
                                </modal>
                            </div>
                        </div>
                        </div>

                        <div class="table-responsive">
                        <table class="table align-items-center table-flush text-center">
                            <tr>
                                <th>No.</th>
                                <th>Floor name</th>
                                <th>Manage</th>
                            </tr>

                            <tr v-for="(floor,index) in floorData" :key="index" :class="{editing: floor == dataEdit}" v-cloak>
                            <td>{{index+1}}</td>
                            <td class="budget">
                                <div class="view">
                                <span>{{floor.floor}}</span>
                                <small @click="goRoom(floor.floor)"><router-link class="text-blue" to="#"> setting room</router-link></small>
                                </div>
                                <div class="edit">
                                <base-input alternative=""
                                                    placeholder="App name"
                                                    input-classes="form-control-alternative"
                                                    v-model="floor.floor"
                                />
                                </div>
                            </td>
                            <td>
                                <div class="view">
                                    <span @click="editData(floor)"><router-link class="text-primary" to="#"><i class="fas fa-pen"></i> Edit</router-link></span> |  
                                    <span @click="del(floor)"><router-link class="text-danger" to="#"><i class="far fa-trash-alt"></i> Delete</router-link></span>
                                </div>
                                <div class="edit">
                                    <span @click="saveEdit(floor)"><router-link class="text-success" to="#"><i class="fas fa-save"></i> Save</router-link></span> |  
                                    <span @click="cancelEdit()"><router-link class="text-default" to="#"><i class="far fa-window-close"></i> Cancel</router-link></span>
                                </div>
                            </td>

                            </tr>

                        </table>
                        </div>
                    </div>
                </div>
            </div>
    </div>
</div>
</template>
<script>

  export default {
    name: 'buiding-name',
    data() {
      return {
        title: 'Buiding name',
        buidingData : [],
        floorData : [],
        message : '',
        error :'',
        floor_name : '',
        showCreate : false,
        dataEdit : null,
        listBuiding : '',
        items: [
          {
            text: 'Company',
            to: '/topic'
          },
          {
            text: 'App',
            to: '/app'
          },
          {
            text: 'Hotel',
            to: '/hotel'
          },
          {
            text: 'Buiding',
            to: '/buiding'
          },
          {
            text: 'Floor',
            active: true
          }
        ]
      }
    },
    created() {
        this.getDataBuiding()
        this.getDataFloor()
    },
    methods: {
        getDataBuiding(){
            this.error = ''
            this.$http.get('/manage/buiding/'+localStorage.user_id+'/'+ localStorage.app_id+'/'+localStorage.hotel_id)
            .then(response => {
                if(!response.data.message){
                    this.buidingData = response.data
                    this.listBuiding = localStorage.buiding
                }else{
                    this.message = response.data.message
                }
          })
        },
        getDataFloor(){
            this.error = ''
            this.$http.get('/manage/floor/'+localStorage.user_id+'/'+ localStorage.app_id+'/'+localStorage.hotel_id
            +'/'+localStorage.buiding)
            .then(response => {
                if(!response.data.message){
                    this.floorData = response.data
                }else{
                    this.message = response.data.message
                    this.floorData = []
                }
          })
        },
        checkData(){
            if(this.floor_name === ''){
                this.error = 'Please enter floor name'
            }else{
                this.sendCreate()
            }
        },
        sendCreate(){
            this.$http.post('/manage/floor/create',{
                user_id : localStorage.user_id,
                app_id : localStorage.app_id,
                hotel_id : localStorage.hotel_id,
                buiding : localStorage.buiding,
                floor : this.floor_name
            })
          .then(response => {
              if(response.data.message === 'success'){
                this.$swal({
                    title: "Created!",
                    icon: "success",
                    timer: 3000
                })
                this.getDataFloor()
                this.showCreate = false
                this.floor_name = ''
                this.error = ''
              }else if(response.data.message === 'cant_create'){
                  this.error = 'Can not use this floor name !!'
              }
          })
          .catch(() => this.checkCreateFloor())
        },
        checkCreateFloor(){
            this.error = 'Create failed!!'
        },
        editData(floor){
            localStorage.floor = floor.floor
            this.dataEdit = floor
        },
        cancelEdit(){
            this.dataEdit = null
            this.getDataFloor()
        },
        saveEdit(floor){
            this.$swal({
                    title: "Confirm edit floor name?",
                    icon: "warning",
                    buttons: ['cancel','confirm']
                })
                .then((confirm) => {
                    if (confirm) {
                            this.$http.post('/manage/floor/edit',{
                            user_id : localStorage.user_id,
                            hotel_id : localStorage.hotel_id,
                            app_id : localStorage.app_id,
                            buiding : localStorage.buiding,
                            floor_old : localStorage.floor,
                            floor : floor.floor
                        })
                        .then(response => {
                            if(response.data.message === 'cant_edit'){
                                this.checkEditFloor()
                            }else if(response.data.message === 'success'){
                                this.$swal({
                                title: "Edited!",
                                icon: "success",
                                timer: 3000
                                })
                                this.getDataFloor()
                            }
                        })
                        .catch(() => this.checkEditFloor())
                    }
                })
        },
        del(floor){
                this.$swal({
                    title: "Confirm delete floor name!!",
                    icon: "warning",
                    buttons: ['cancel','confirm'],
                    dangerMode: true
                }).then((confirm) => {
                    if (confirm) {
                            this.$http.post('/manage/floor/del',{
                            user_id : localStorage.user_id,
                            hotel_id : localStorage.hotel_id,
                            app_id : localStorage.app_id,
                            buiding : localStorage.buiding,
                            floor : floor.floor
                        })
                        .then(response => {
                            if(response.data.message === 'success'){
                                this.$swal({
                                title: "Deleted!",
                                icon: "success",
                                timer: 3000
                                })
                            }
                            this.getDataFloor()
                        })
                        .catch(() => this.error = 'Delete failed!!' )
                    }
                })
        },
        checkEditFloor(){
            this.error = 'Edit failed!!'
        },
        getBuiding(){
            localStorage.buiding = this.listBuiding
            this.getDataFloor()
        },
        goRoom(floor){
            localStorage.floor = floor
            this.$router.push('/room')
        }
    },
  };
</script>
<style scoped>
[v-cloak] {
      display: none;
    }
    .edit {
      display: none;
    }
    .editing .edit {
      display: block
    }
    .editing .view {
      display: none;
    }
</style>